<?php $pageTitle='Configuration';
include realpath(__DIR__).'/../_common/header.php'; ?>
<script type="text/javascript">

document.observe("dom:loaded",function(){
	
	ui.grid();

	var ts=grid.tabSet({ classes:'r1 c1 h3 w3' });

	var imagingTab=ts.tab({ 
		id:'imagers', 
		label:'Imagers', 
		content:'<p class="loadingmsg">Loading config...</p>', 
	 });
	var storageTab=ts.tab({ 
		id:'storage', 
		label:'Storage &amp; Backup', 
		content:'<p class="loadingmsg">Loading config...</p>', 
	 });
	var authTab=ts.tab({ 
		id:'auth', 
		label:'Authentication', 
		content:'<p class="loadingmsg">Loading config...</p><p>Icebear currently supports username/password configuration via its own database.</p><p>Later versions will support LDAP/AD authentication. If you intend to use these later, your life will be easier if people\'s Icebear usernames are the same as their LDAP/AD usernames.</p>', 
	 });

	getConfig();

	//Override this function to submit to /api/config/itemname
	ui.doUpdateFormField=function(field){
		if(field.oldvalue==field.value){ return false; }
		if(field.up("label,td")){ field.up("label,td").addClassName("updating"); }
		var body;
		if(field.type && field.type=="checkbox"){
			body=field.name+"="+(field.checked ? "1" : "0")+"&csrfToken="+csrfToken
			field.oldvalue=field.checked ? "0" : "1";
		} else {
			field.oldvalue=field.value;
			body=field.name+"="+encodeURIComponent(field.value)+"&csrfToken="+csrfToken
		}
		window.setTimeout(function(){
			new Ajax.Request('/api/config/'+field.name,{
				method:'patch',
				postBody:body,
				onSuccess:function(transport){ ui.updateFormField_onSuccess(transport,field) },
				onFailure:function(transport){ ui.updateFormField_onFailure(transport,field) }
			});
		},250);
	};
	
});

function getConfig(){
	new Ajax.Request('/api/config/',{
		method:'get',
		onSuccess:renderConfig,
		onFailure:getConfigFailed
	});
}
function getConfigFailed(transport){
	alert("Could not retrieve configuration from server.");
}
function renderConfig(transport){

		var config={};
		transport.responseJSON.rows.each(function(ci){
			config[ci.name]=ci;
		});
	
		var tabFields={
			'imagers':[
						'Section:Manual imaging','imaging_allowmanual',
						'Section:Formulatrix imagers','fx_hasimagers','fx_dbhost','fx_dbport','fx_dbuser','fx_dbpass','fx_rmdbname','fx_ridbname',
 						'Section:Rigaku','rigaku_hasimagers','rigaku_platepath','rigaku_imagepath','rigaku_thumbpath'
			],
			'storage':[
						'Section:Crystal image storage','core_imagestore','core_imagestorebackup',
						'Section:Uploaded file storage','core_filestore','core_filestorebackup',
						'Section:Database backup','core_databasebackup','core_databasebackupstokeep',
			],
			'auth':['Section:Timeout','auth_timeout_mins'],
		}

		Object.keys(tabFields).each(function(t){
			var tb=$(t+'_body');
			tb.down(".loadingmsg").remove();
			var f=tb.form('/api/config');
			tabFields[t].each(function(field){
				if(0===field.indexOf("Section:")){
					f.insert({bottom:'<label><h3>'+field.substr(8).trim()+'</h3></label>'});
				} else {
					var configItem=config[field];
					if(!configItem){
						f.textField({
							label:'<span style="color:red">Unknown config item '+field+'</span>',
							name:'bogus',
							value:'',
							readonly:true
							
						});
					} else if("enum"==configItem.type){
						alert(configItem.enumvalues)
						var parts=configItem.enumvalues.trim("'");
						parts=parts.split("','");
						var options=[];
						parts.each(function(p){ 
							p=p.replace("'","");
							options.push({ label:p, value:p });
						});
						f.dropdown({
							label:configItem.description,
							name:configItem.name,
							options:options,
							value:configItem.value
						});
					} else if("text"==configItem.type){
						f.textField({
							label:configItem.description,
							name:configItem.name,
							value:configItem.value
						});
					} else if("int"==configItem.type){
						f.textField({
							label:configItem.description,
							name:configItem.name,
							value:configItem.value
						});
					} else if("boolean"==configItem.type){
						f.checkbox({ 
							label:configItem.description,
							name:configItem.name,
							value:configItem.value
						});
					}
				}
			});
		});
		
}


</script>
<?php include realpath(__DIR__).'/../_common/footer.php'; ?>